/*
 * Ukazka vyuziti autoboxingu a generickych kontejneru.
 */
package ija.collections.collections;

import java.util.*;

/**
 * Prints a frequency table of the words on the command line
 * @author Radek Koci
 */
public class Frequency {
    public static void main(String[] args) {
        Frequency.m1(args);
        Frequency.m2(args);
    }

    public static void m1(String[] args) {
	Map m = new TreeMap();
	for (int i=0; i<args.length; i++) {
	    String word = args[i];
	    Integer freq = (Integer) m.get(word);
	    m.put(word, (freq == null ? new Integer(1) : new Integer(freq.intValue() + 1)));
	}
	System.out.println(m);
    }

    public static void m2(String[] args) {
	Map<String, Integer> m = new TreeMap<String, Integer>();
	for (String word : args) {
	    Integer freq = m.get(word);
	    m.put(word, (freq == null ? 1 : freq + 1));
	}
	System.out.println(m);
    }

}
