/*
 * Ukazka pouziti SortedMap.
 */
package ija.collections.collections;

import java.util.*;

/**
 * Ukazka pouziti SortedMap. Vyuziti generics a for-each loop.
 * @author Radek Koci
 */
public class SortedMapDemo {
    public static void main(String[] args) {
//	SortedMap<Clovek, Ucet> mapa = new TreeMap<Clovek, Ucet>();
	SortedMap<CorrectPerson, Ucet> mapa = new TreeMap<CorrectPerson, Ucet>(new ClComparator());
	CorrectPerson c1 = new CorrectPerson("Ferda");
	CorrectPerson c2 = new CorrectPerson("Franta");
	CorrectPerson c3 = new CorrectPerson("Cecil");
	
	mapa.put(c1, new Ucet(500));
	mapa.put(c2, new Ucet(100));
	mapa.put(c3, new Ucet(300));
	
	for(CorrectPerson majitel : mapa.keySet()) {
	    Ucet ucet = mapa.get(majitel);
	    majitel.vypisInfo();
	    System.out.println(" je majitelem uctu se zustatkem " + ucet.zustatek + " Kc.");
	} 
    }
    
    static private class Ucet {
	double zustatek;
	public Ucet(double  z) {
	    zustatek = z;
	}
    }
   
    static private class ClComparator implements Comparator {

	public int compare(Object o1, Object o2) {
	    if (o1 instanceof Person && o2 instanceof Person) {
		Person c1 = (Person) o1;
		Person c2 = (Person) o2;
                // primy pristup k promennym objektu (stejny balik)
                // pri zmene baliku by nefungovalo!
		return c1.name.compareTo(c2.name);
	    }
	    else
		throw new IllegalArgumentException("Nelze porovnat ...");
	}
    }
}
